unit bn_test;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, ComCtrls, RSA, ExtCtrls;

type
  TfrmRSATest = class(TForm)
    RSA1:          TRSA;
    btnCreateKey:  TButton;
    btnEncrypt:    TButton;
    edtPublicKey:  TEdit;
    edtPrivateKey: TEdit;
    sbStatus:      TStatusBar;
    edtTestText:   TEdit;
    btnDecrypt:    TButton;
    grpKeyLength:  TGroupBox;
    rbn512:        TRadioButton;
    rbn1024:       TRadioButton;
    rbn2048:       TRadioButton;
    rbn4096:       TRadioButton;
    lblPrivateKey: TLabel;
    lblPublicKey:  TLabel;
    lblTestText:   TLabel;
    procedure      btnCreateKeyClick(Sender: TObject);
    procedure      RSA1StatusUpdate(Sender: TObject);
    procedure      rbn512Click(Sender: TObject);
    procedure      rbn1024Click(Sender: TObject);
    procedure      rbn2048Click(Sender: TObject);
    procedure      btnEncryptClick(Sender: TObject);
    procedure      btnDecryptClick(Sender: TObject);
    procedure rbn4096Click(Sender: TObject);
  end;

var
  frmRSATest: TfrmRSATest;

implementation

{$R *.DFM}

{*******************************************************************************
* Procedure : TfrmRSATest.btnCreateKeyClick                                    *
********************************************************************************
* Purpose   : Calls the TRSA procedure for making key pairs using the currently*
*             selected key length                                              *
********************************************************************************
* Paramters : None                                                             *
********************************************************************************
* Returns   : None                                                             *
*******************************************************************************}
procedure TfrmRSATest.btnCreateKeyClick(Sender: TObject);
begin
     // create the key pair
     RSA1.MakeKeyPair;

     // show the user the values
     edtPublicKey.Text := RSA1.PublicKey;
     edtPrivateKey.Text := RSA1.PrivateKey;
end; {TForm1.btnCreateKeyClick}

{*******************************************************************************
* Procedure : TfrmRSATest.btnEncryptClick                                      *
********************************************************************************
* Purpose   : Calls the TRSA procedure for encrypting data using the currently *
*             loaded keys                                                      *
********************************************************************************
* Paramters : None                                                             *
********************************************************************************
* Returns   : None                                                             *
*******************************************************************************}
procedure TfrmRSATest.btnEncryptClick(Sender: TObject);
var
     TempString: string;
begin
     RSA1.EncryptString(edtTestText.Text, TempString);
     edtTestText.Text := TempString;
end;

procedure TfrmRSATest.btnDecryptClick(Sender: TObject);
var
     TempString: string;
begin
     RSA1.DecryptString(edtTestText.Text, TempString);
     edtTestText.Text := TempString;
end;


procedure TfrmRSATest.RSA1StatusUpdate(Sender: TObject);
begin
     sbStatus.SimpleText := RSA1.Status;     
end;


procedure TfrmRSATest.rbn512Click(Sender: TObject);
begin
     RSA1.KeyBits := kb0512;
end;

procedure TfrmRSATest.rbn1024Click(Sender: TObject);
begin
     RSA1.KeyBits := kb1024;
end;

procedure TfrmRSATest.rbn2048Click(Sender: TObject);
begin
     {RSA1.KeyBits := kb2048;}
end;

procedure TfrmRSATest.rbn4096Click(Sender: TObject);
begin
     {RSA1.KeyBits := kb4096;}
end;

end.
